<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="原料编号" prop="materialId">
        <el-input v-model="queryParams.materialId" placeholder="请输入原料编号" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="原料名称" prop="materialName">
        <el-input v-model="queryParams.materialName" placeholder="请输入原料名称" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="比例" prop="ratio">
        <el-input v-model="queryParams.ratio" placeholder="请输入比例" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd"
          v-hasPermi="['feed:FormulaList:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"
          v-hasPermi="['feed:FormulaList:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['feed:FormulaList:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport"
          v-hasPermi="['feed:FormulaList:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="FormulaListList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="序号" align="center" prop="code" />
      <el-table-column label="配方编号" align="center" prop="formulaId" />
      <el-table-column label="原料编号" align="center" prop="materialId" />
      <el-table-column label="原料名称" align="center" prop="materialName" />
      <el-table-column label="比例" align="center" prop="ratio" />
      <el-table-column label="颗粒原料" align="center" prop="isGranular" />
      <el-table-column label="补饲" align="center" prop="isSupplement" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['feed:FormulaList:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
            v-hasPermi="['feed:FormulaList:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改配方列表对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="FormulaListRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="原料编号" prop="materialId">
          <el-input v-model="form.materialId" placeholder="请输入原料编号" />
        </el-form-item>
        <el-form-item label="原料名称" prop="materialName">
          <el-input v-model="form.materialName" placeholder="请输入原料名称" />
        </el-form-item>
        <el-form-item label="比例" prop="ratio">
          <el-input v-model="form.ratio" placeholder="请输入比例" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="FormulaList">
import { listFormulaList, getFormulaList, delFormulaList, addFormulaList, updateFormulaList } from "@/api/feed/FormulaList"
import { reactive } from "vue"

const { proxy } = getCurrentInstance()

const FormulaListList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    batchId: "0",
    materialId: null,
    materialName: null,
    ratio: null,
    isGranular: null,
    isSupplement: null
  },
  rules: {
    ratio: [
      { required: true, message: "比例不能为空", trigger: "blur" }
    ],
  }
})

const { queryParams, form, rules } = toRefs(data)


/** 查询配方列表列表 */
function getList() {
  loading.value = true
  listFormulaList(queryParams.value).then(response => {
    FormulaListList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    code: null,
    formulaId: null,
    materialId: null,
    materialName: null,
    ratio: null,
    isGranular: null,
    isSupplement: null
  }
  proxy.resetForm("FormulaListRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.code)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加配方列表"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _code = row.code || ids.value
  getFormulaList(_code).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改配方列表"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["FormulaListRef"].validate(valid => {
    if (valid) {
      if (form.value.code != null) {
        updateFormulaList(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addFormulaList(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _codes = row.code || ids.value
  proxy.$modal.confirm('是否确认删除配方列表编号为"' + _codes + '"的数据项？').then(function () {
    return delFormulaList(_codes)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => { })
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('feed/FormulaList/export', {
    ...queryParams.value
  }, `FormulaList_${new Date().getTime()}.xlsx`)
}

getList()
</script>
